Index: trunk/Cosmo/SimLSS/cmvdefsurv.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvdefsurv.cc	(revision 3341)
+++ trunk/Cosmo/SimLSS/cmvdefsurv.cc	(revision 3343)
@@ -69,5 +69,5 @@
  double h75 = h100 / 0.75;
  double nstar = 0.006*pow(h75,3.);  //
- double mstar = pow(10.,9.8/(h75*h75));  // MSol
+ double mstar = pow(10.,9.8);  // MSol
  double alpha = -1.37;
  cout<<"nstar= "<<nstar<<"  mstar="<<mstar<<"  alpha="<<alpha<<endl;
@@ -299,5 +299,5 @@
  cout<<"mstar*sch(mstar) = "<<sch(mstar)<<" Msol/Mpc^3/Msol"<<endl;
  int npt = 10000;
- double lnx1=log10(1e-6), lnx2=log10(1e+14), dlnx=(lnx2-lnx1)/npt;
+ double lnx1=log10(1e+6), lnx2=log10(1e+14), dlnx=(lnx2-lnx1)/npt;
  double masshimpc3 = IntegrateFuncLog(sch,lnx1,lnx2,0.001,dlnx,10.*dlnx,6);
  cout<<"Mass density: "<<masshimpc3<<" Msol/Mpc^3"<<endl;
@@ -308,4 +308,15 @@
      <<"Total mass in survey = "<<masshitot<<" Msol"<<endl;
  if(mhiref<=0.)  mhiref = masshipix;
+
+ sch.SetOutValue(0);
+ cout<<"\nsch(mstar) = "<<sch(mstar)<<" /Mpc^3/Msol"<<endl;
+ cout<<"Galaxy number density:"<<endl;
+ for(double x=lnx1; x<10.5; x+=1.) {
+   double n = IntegrateFuncLog(sch,x,lnx2,0.001,dlnx,10.*dlnx,6);
+   cout<<"  m>"<<x<<" Msol: "<<n<<" /Mpc^3, "<<n*dvol<<" /pixel, "
+       <<n*vol<<" in survey"<<endl;
+ }
+ sch.SetOutValue(1);
+
 
  // --- Survey values
@@ -368,7 +379,8 @@
  double tsig = facpolar * tsig_2polar;
  double ssig = facpolar * ssig_2polar;
- cout<<"\nSignal("<<mhiref<<" Msol): P="<<psig<<" W"<<endl;
- cout<<"     flux density = "<<ssig<<" Jy  (for Dnu="<<dnuhiz<<" GHz)"<<endl;
- cout<<"     Antenna temperature: tsig="<<tsig<<" K"<<endl;
+ cout<<"\nSignal("<<mhiref<<" Msol):"<<endl
+     <<"     P="<<psig<<" W"<<endl
+     <<"     flux density = "<<ssig*1.e6<<" mu_Jy  (for Dnu="<<dnuhiz<<" GHz)"<<endl
+     <<"     Antenna temperature: tsig="<<tsig<<" K"<<endl;
 
  // Elargissement doppler de la raie a 21cm: dNu = vrot/C * Nu(21cm) / (1+z)
@@ -390,6 +402,6 @@
  cout<<"\nSynchrotron: T="<<Tsynch408<<" K ("<<nuhaslam<<" GHz), "
      <<tsynch<<" K ("<<nuhiz<<" GHz)"<<endl
-     <<"             P="<<psynch<<" W for pixel"<<endl;
- cout<<"             flux density = "<<ssynch<<" Jy for pixel solid angle"<<endl;
+     <<"             P="<<psynch<<" W for pixel"<<endl
+     <<"             flux density = "<<ssynch<<" Jy for pixel solid angle"<<endl;
 
  // CMB
@@ -400,6 +412,7 @@
  double pcmb = facpolar * pcmb_2polar;
  double scmb = facpolar * scmb_2polar;
- cout<<"\nCMB: T="<<tcmb<<" K -> P="<<pcmb<<" W for pixel"<<endl;
- cout<<"                       flux density = "<<scmb<<" Jy for pixel solid angle"<<endl;
+ cout<<"\nCMB: T="<<tcmb<<" K"<<endl
+     <<"     P="<<pcmb<<" W for pixel"<<endl
+     <<"     flux density = "<<scmb<<" Jy for pixel solid angle"<<endl;
 
  // AGN
Index: trunk/Cosmo/SimLSS/cmvobserv3d.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvobserv3d.cc	(revision 3341)
+++ trunk/Cosmo/SimLSS/cmvobserv3d.cc	(revision 3343)
@@ -86,5 +86,5 @@
  double h75 = h100 / 0.75;
  double nstar = 0.006*pow(h75,3.);
- double mstar = pow(10.,9.8/(h75*h75));  // MSol
+ double mstar = pow(10.,9.8);  // MSol
  double alpha = -1.37;
 
Index: trunk/Cosmo/SimLSS/cmvschdist.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvschdist.cc	(revision 3341)
+++ trunk/Cosmo/SimLSS/cmvschdist.cc	(revision 3343)
@@ -48,5 +48,5 @@
  double h75 = 0.71 / 0.75;
  double nstar = 0.006*pow(h75,3.);  //  
- double mstar = pow(10.,9.8/(h75*h75));  // MSol
+ double mstar = pow(10.,9.8);  // MSol
  double alpha = -1.37;
  cout<<"h75= "<<h75<<" nstar= "<<nstar<<"  mstar="<<mstar<<"  alpha="<<alpha<<endl;
Index: trunk/Cosmo/SimLSS/cmvtstsch.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvtstsch.cc	(revision 3341)
+++ trunk/Cosmo/SimLSS/cmvtstsch.cc	(revision 3343)
@@ -37,5 +37,5 @@
  double h75 = 0.71 / 0.75;
  double nstar = 0.006*pow(h75,3.);  //  
- double mstar = pow(10.,9.8/(h75*h75));  // MSol
+ double mstar = pow(10.,9.8);  // MSol
  double alpha = -1.37;
  cout<<"h75= "<<h75<<" nstar= "<<nstar<<"  mstar="<<mstar<<"  alpha="<<alpha<<endl;